<?php

namespace xenarabia\REP001;

use XF\AddOn\AbstractSetup;
use XF\AddOn\StepRunnerInstallTrait;
use XF\AddOn\StepRunnerUninstallTrait;
use XF\AddOn\StepRunnerUpgradeTrait;

use XF\Db\Schema\Alter;

class Setup extends AbstractSetup
{
	use StepRunnerInstallTrait;
	use StepRunnerUpgradeTrait;
	use StepRunnerUninstallTrait;

	public function installStep1(array $stepParams = [])
	{
		$this->schemaManager()->createTable('xa_reputation', function(\XF\Db\Schema\Create $table)
		{
			$table->addColumn('rep_id', 'int')->autoIncrement();
			$table->addColumn('rep_sender_id', 'int');
			$table->addColumn('rep_receiver_id', 'int');
			$table->addColumn('rep_post_id', 'int');
			$table->addColumn('rep_thread_id', 'int');
			$table->addColumn('rep_text', 'text');
			$table->addColumn('rep_rate', 'int')->setDefault(0);
			$table->addColumn('rep_date', 'varchar', 255);
		});
	}

	public function installStep2()
	{
		$this->schemaManager()->alterTable('xf_user_group', function(Alter $table)
		{
			$table->addColumn('rep_points', 'int')->setDefault(1);
		});
		$this->schemaManager()->alterTable('xf_user', function(Alter $table)
		{
			$table->addColumn('rep_user', 'int')->setDefault(0);
		});

	}


	public function uninstall(array $stepParams = [])
	{
		$this->schemaManager()->dropTable('xa_reputation');
		$this->schemaManager()->alterTable('xf_user_group', function(Alter $table)
		{
			$table->dropColumns('rep_points', 'int');
		});
		$this->schemaManager()->alterTable('xf_user', function(Alter $table)
		{
			$table->dropColumns('rep_user', 'int');
		});

	}
}