<?php

namespace xenarabia\REP001\XF\Entity;

use XF\Mvc\Entity\Structure;

class Post extends XFCP_Post
{

    // public function canReceiveWhispers(\XF\Entity\User $user)
    // {
        
	// 	// $visitor = \XF::visitor();
    //     return $user->Privacy->isPrivacyCheckMet('allow_send_whisper', $this);
    // }


    public static function getStructure(Structure $structure)
    {

        $structure = parent::getStructure($structure);
        $structure->getters += [
            'is_user_rep' => ['getter' => 'isUserRep', 'cache' => false],
            'get_rep_id' => ['getter' => 'getRepId', 'cache' => false],
        ];
    return $structure; 
    }

    public function isUserRep()
    {
        $postRep = $this->queryRep()->total();

        if($postRep > 0)
        {
            return false;
        }

        return true;
    }

    public function getRepId()
    {
        return $this->queryRep()->fetchOne()->rep_id;
    }

    public function getRepInfo()
    {
        return $this->queryRep()->fetchOne();
    }

    public function queryRep()
    {
        return $this->finder('xenarabia\REP001:RepEntity')
        ->where('rep_post_id', $this->post_id)
        ->where('rep_sender_id', \XF::visitor()->user_id);
    }


    public function getRepPerDay()
    {
        $limitTime = \XF::$time + 86400;
        return $this->finder('xenarabia\REP001:RepEntity')
        ->where('rep_sender_id', \XF::visitor()->user_id)
        ->where('rep_date', '<=',$limitTime)->total();
    }


}