<?php

namespace xenarabia\REP001\XF\Pub\Controller;

use XF\Mvc\ParameterBag;

class Account extends XFCP_Account{

    public function actionReputations()
    {

		$visitor = \XF::visitor();

		/** @var \xenarabia\REP001\Entity\RepEntity $repotuations */
        $repReputations = $this->finder('xenarabia\REP001:RepEntity')->where('rep_receiver_id' , $visitor->user_id)->order('rep_id', 'DESC');
		$page = $this->filterPage();
		$perPage = 20;

		/** @var ArrayCollection|\XF\Entity\ReactionContent[] $reactions */
		$reputations = $repReputations->limitByPage($page, $perPage)->fetch();
		$reputations = $reputations->slice(0, $perPage);


		$viewParams = [
			'reputations' => $reputations,
			'page' => $page,
            'perPage' => $perPage,
            'totalReputations' => $repReputations->total(),
		];
		$view = $this->view('XF:Account\Reactions', 'account_reputations', $viewParams);
		return $this->addAccountWrapperParams($view, 'reputations');
    }
}